;**********************************************************
;Program : ZAS_WAR.A51 w Asembler dla AT89C2051
;Autor : MIM
;VER: P3 dla ukladu
;Ostatnia edycja : 23.08.2003
;**********************************************************
$NOMOD51                ;NIE uzywaj zestawu instrukcji dla Typowego 51
$INCLUDE(89C2051.MCU)   ;Uwzglednij injstrukcje tylko dla AT89C2051

;Podzial komorek RAM (0..128 byte=00..07Fh)
;Moga byc "luki" ale nie moze byc "powtorzen" !!!
; i wszytkie musza sie miescic w zakresie 000h - 07Fh=(128dec) !!!!
;               EQU 7Fh  koniec wolnego RAM
;.
;.
;               EQU 3Eh  poczatek wolnego RAM
Disp_Flash_ON   EQU 3Dh ;Migac=1/NIE Migac=0
Disp_D_L_Time   EQU 3Ch ;Czas Swieci("pipa")/NIE Swieci(NIE "pipa"
Disp_DL         EQU 3Bh ;Wskaznik LCD 1=Swieci 0=NIE Swieci
Relay_Data_BIN  EQU 3Ah ;BINarna wartosc nastawy
Disp_Data_100   EQU 39h ;Wartosc nastawiona - 100-ki BCD bity 3..0
Disp_Data_010   EQU 38h ;Wartosc nastawiona -  10-ki BCD bity 3..0
Disp_Data_001   EQU 37h ;Wartosc nastawiona -   1-ki BCD bity 3..0
Disp_Nr         EQU 36h ;Ktry segment ostatnio swiecil
Klaw_Kod_Odcz   EQU 35h ;kod klawiszy odczytany "swoj" - wg ukladu klawiatury
Klaw_ASCII_2    EQU 34h ;po przetworzeniu wg. tablic (lewy skrajny -100-ki)
Klaw_ASCII_1    EQU 33h ;po przetworzeniu wg. tablic (srodkowy     - 10-ki)
Klaw_ASCII_0    EQU 32h ;po przetworzeniu wg. tablic (prawy skrajny- 1-ki)
Klaw_do_Analizy EQU 31h ;zawsze ASCII "0","1"..."9","+","-"- inne odrzucane !
                        ;uzyte w procedurze Analizy
Power_ON_OFF    EQU 30h ;Stan zasilacza : 0=jest WYL / 1=jest ZAL
Rez_2Fh         EQU 2Fh ;Rezerwa
Rez_2Eh         EQU 2Eh ;Rezerwa
Il_Wprow_Cyfr   EQU 2Dh ;Ilosc wprowadzonych cyfr (1..3)
Rez_2Ch         EQU 2Ch ;Rezerwa
Tryb_Wpr        EQU 2Bh ;Tryb Wprowadzania 0=NIE/1=TAK
Klaw_Zap        EQU 2Ah ;Dla proced. Czy nadal nacisniety ?
Maska_pip       EQU 29h ;"pipaj"/NIE "pipaj" bit P1.6 !

;EQU 28
;.
; do wykorzystania
;.
;....
Stos_Poczatek   EQU 07h ;Poczatek stosu
;********************************************************************
org     0000h               ;RST
                            jmp Inicjacja

org     0003h               ;INT0
                            reti

org     000Bh               ;TIMER 0
                            jmp IRQ_T0_Time
                            reti

org     0013h               ;INT1
                            reti

org     001Bh               ;TIMER 1
                            reti

org     0023h               ;RS232 INT
                            reti

org     002Bh               ;I2C_Interupt S1CON_bit_3 (SI) tylko 552
                            reti
;********************************************************************
org     0100h               
Inicjacja:                  ;Inicjacja programu
                            ;Wartosci poczatkowe

;Porty : P1 , P3 - wartosci poczatkowe
                        mov P1,#00h     ;wszystkie na "0"
                                        ;P1.3..P1.0 - Data:Disp/Przek. H/L
                                        ;P1.4 - 40175(2) strob L
                                        ;P1.5 - 40175(1) strob H
                                        ;P1.6 - 40175(2),40175(1)-RESET i "pip"
                                        ;P1.7 - 4543 strob LED Display

                        mov P3,#0FFh    ;wszystkie na "1"
                                        ;P3.2 P3.0-Stroby segmentu2 (100-ki)
                                        ;                         1 (10-ki)
                                        ;                         0 (1-ki)
                                        ;P3.7..P3.3 - jako INPUT
                                        ;P3.7..P3.3-odczt. kol. 3..0 klaw.
                                        ;P3.6 - Niedostepny !

;Zerowanie przekaznikow
;Zerowanie komorki stanu przekaznikow
mov Relay_Data_BIN,#000     ;BINarna wartosc nastawy
;"Fizyczne ZEROWANIE" przekaznikow z "PIP-1 sek"
Reset_po_ZAL_Sieci:         setb P1.6       ;Strob RESET_ON przekaznikow
                            ;Jezeli "Pipek" jest podlaczony do oporu Reset
                            ;to ok. 1 sek "pipania"
                            mov A,#10
                            call Pipaj_A_razy_100_ms
                            clr  P1.6       ;Strob RESET_OFF przekaznikow
                            ;Przekazniki w stanie WYLaczone
;Inne ustawienia
;Zerowanie RAM
mov R0,#7Fh     ;ilosc RAM=80h=128dec liczac od 00h to koniec=7Fh
mov R1,#00h     ;0-wy adres RAM
mov A,#00h      ;
Zeruj_RAM:      mov @R0,#00h
                djnz R0,Zeruj_RAM

;Ustawienia TIMERa0 dla przerwan co. ok 5 ms
TimerHigh       SET 0EFh    ;Licznik czasu H
TimerLow        SET 089h    ;Licznik czasu L
                            ;przy f=12MHz i podziale TM0 : 12 !
                            ;czas wyswietlania  segmentu ok. 5ms
;Dla "Migania"
D_L_Time_Long   SET 0BEh    ;Czas Swiec/NIESwiec-Mig. wolne dla stanu OFF
D_L_Time_Short  SET 0EFh    ;Czas Swiec/NIESwiec-Mig. szybkie dla trybu Wprowadz
                            ;ok. 1/4 czasu migania w trybie WYLaczony

                            ;Dla obslugi wyswietlacza i odczytu klawiatury
mov Disp_Nr,#00h            ;Ktry segment ostatnio swiecil , Na WEJ 0-wy

                            ;Dla procedury obslugi klawiatury :
IlElTab         SET 12d     ;ilosc elementow tablic przetworzen kodow
mov Klaw_Kod_Odcz,#0FFh     ; "0".."9" , "+" , "-" - kod klawiszy
                            ;255=FFh gdy nie nacisnieto
mov Klaw_do_Analizy,#0FFh   ;Wstepna wartosc=NIE Nacisnieto klawisza

;Po zalaczeniu sieci ma byc :
;ZALaczony (NIE Miga ale Swieci) , dostepne <+=INC> i <-=DEC>
mov Disp_Flash_ON,#0        ;Migac=1/NIE Migac=0
mov Disp_DL,#1              ;Swiec
;"pipanie w trybie wprowadzania
mov Maska_pip,#00000000b    ;B6=1-"pipac"/B6=0-NIE "pipac"

;Stan ZALaczony z wartoscia Napiecia=000
;000 V przekazniki

;Do wyswietlacza "..0"
mov A,Relay_Data_BIN
;WE:A=00
call Byte_na_liczbe_100_10_1

;Stan Power_ON_OF = ON (ZALaczony ale Vwy=000 V !!!)
;Stan ON - tzn. tryb INC-DEC
mov Power_ON_OFF,#1         ;0=jest WYL / 1=jest ZAL

;Ustawienia poczatkowe dla trybu wprowadzania :
mov Il_Wprow_Cyfr,#00h      ;Ilosc wprowadzonych cyfr : 0..2
mov Tryb_Wpr,#0             ;Tryb Wprowadzania 0-NIE/1-TAK

;1-sze ustawienie czasow przerwania , pozniej ustawia sie w procedu. IRQ
mov TH0,#TimerHigh          ;Czas przerwania H
mov TL0,#TimerLow           ;Czas przerwania H

;Dane dla przerwan czyli obslugi LED_DISplay
                            ;Dozwolone Przerwania
                            setb EA             ;Zezwolenie na przerwania

                            ;Ustawienie TIMERA 0
                            ;         76543210
                            mov TMOD,#00000001b ;MODE 1 (16 bit)
                            mov TH0,#TimerHigh
                            mov TL0,#TimerLow
                            ;Zal Timer 0
                            setb tr0            ;start licznika TIMER 1

                            setb ET0            ;Zezwolenie na przerwania T0
                            jmp Start_Programu

;==========================================================
IRQ_T0_Time:                ;Obsluga przerwania TIMER 0

                            clr tr0  ;STOP licznika TIMER 0

                            ;Zmien Segment swiecacy
                            ;odczytaj klwiature
                            ;WE: Disp_Nr
                            call Wys_i_Odczyt_Klaw
                            ;WY: Segment : 0,1,2 wyswietlony
                            ;    Klawisz odczytany , w ASCII tabeli
                            ;Czas na nastepne przerwanie
                            mov TH0,#TimerHigh
                            mov TL0,#TimerLow

                            setb tr0 ;START licznika TIMER 0

IRQ_T0_Time_End:            reti
;==========================================================
;############################
Sprawdz_Kl_ASCII:
;WY:A=Klawisz ASCII
                        mov R0,#Klaw_ASCII_0    ;adres bazowy
                        mov R1,#3               ;sa 3 komorki Klaw_ASCII_x
Sprawdz_Kl_ASCII_Next:  mov A,@R0               ;pobranie kodu
                        cjne A,#0FFh,Sprawdz_Kl_ASCII_End  ;!JEST! kod klawisza
                        ;sprawdz nastepny
                        inc R0
                        djnz R1,Sprawdz_Kl_ASCII_Next
                        ;nie znaleziono
                        mov A,#0FFh
                        jmp Sprawdz_Kl_ASCII_End
Sprawdz_Kl_ASCII_End:   ret
;############################
Start_Programu:
Petla_Glowna:
PG_Sprawdz_Kl_ASCII:    call Sprawdz_Kl_ASCII
                        ;WY:A=Klawisz ASCII

                        cjne A,#0FFh,Czy_nie_00h
                        ;A=0FFh
                        jmp Petla_Glowna

Czy_nie_00h:            cjne A,#00h,PG_Nac_Klaw
                        ;Nielegalna wratosc-moze sie pojawic
                        jmp Petla_Glowna

PG_Nac_Klaw:            mov Klaw_Zap,A  ;Zapamietanie nacisnietego klawisza
                        mov A,#10       ;Czas Tu patrz rys.
                        call Delta_Time_Ms
                        ;czas "Tu" minal - czas na uspokojenie klawisza
                        call Sprawdz_Kl_ASCII
                        ;WY:A=Klawisz ASCII
                        cjne A,Klaw_Zap,PG_Koniec_Powtarzaj ;Klawisz zwolniono
                                                            ;przed uplywem czasu
                                                            ;"Tu" na uspokojenie
                                                            ;(rys.1)
                        ;A=Klaw_Zap czyli ciagle nacisniety
                        ;   pobrac go do analizy
PG_Nac_Klaw_OK:         mov R6,#245     ;czas "Tsr"=245*2+Tz=490+10=500 (rys.1)
                        mov R7,#5       ;czas "Tz"=5*2=10               (rys.1)
PG_Tz_Tsr:              mov A,#2        ;czs probkowania
                        call Delta_Time_Ms
                        ;czas sprawdzic stan klawiszy
                        call Sprawdz_Kl_ASCII
                        ;WY:A=Klawisz ASCII
                        cjne A,Klaw_Zap,PG_An_Kl_1      ;Klawisz zwolniony
                                                        ;w czasie oczekiwania
                                                        ;na potwierdzenie
                                                        ;repetycji
                        ;A=Klaw_Zap czyli nadal nacisniety
                        djnz R7,PG_Tz_Tsr
                        ;czas "Tz" minal
                        djnz R6,PG_Tz_Set
                        ;czas "Tsr" minal
                        jmp PG_Powtarzaj

PG_Tz_Set:              mov R7,#1       ;Aby wykonac tylko petle "Tsr"
                        jmp PG_Tz_Tsr

PG_An_Kl_1:             mov Klaw_do_Analizy,Klaw_Zap
                        ;WE:Klaw_do_Analizy
                        call Anal_Klaw_i_Wyk_Zad_Funk
                        ;WY: Wykonane funkcje
                        jmp PG_Koniec_Powtarzaj

PG_Powtarzaj:           ;Repetycja
                        mov Klaw_do_Analizy,Klaw_Zap

                        ;WE:Klaw_do_Analizy
                        call Anal_Klaw_i_Wyk_Zad_Funk
                        ;WY: Wykonane funkcje

                        mov A,#250
                        call Delta_Time_Ms      ;"Tr"-250 ms

                        call Sprawdz_Kl_ASCII
                        ;WY:A=Klawisz ASCII

                        cjne A,Klaw_Zap,PG_Koniec_Powtarzaj     ;Gdy klawisz
                                                                ;zwolniony
                        ;A=Klaw_Zap Nadal nacisniety to powtarzamy
                        jmp PG_Powtarzaj
                        ;Koniec repetycji

PG_Koniec_Powtarzaj:    jmp Petla_Glowna
;==========================================================
Wys_i_Odczyt_Klaw:      ;po przerwaniu T0-obsluga wysw.LED i obsluga klawiatury
                        push Acc
                        push aR0
                        push aR1

                        ;Czy Migac/Nie migac
                        mov A,Disp_Flash_ON ;0=NIE Migac/1=Migac ;"Migac" ?
                        cjne A,#1,Wys_i_Odczyt_Klaw_00           ;nie -
                                                                 ;czyli do
                                                                 ;normalnej
                                                                 ;procedury
                        ;A=1 - Tryb Migania

                        ;Sprawdzic czy czas Swiecenia/NIE Swiecenia minal ?
                        ;Czy czas : Disp_D_L_Time Stan Zgaszony/Zapal. uplynal ?
                        mov A,Disp_D_L_Time               ;_Dark_Light_Time
                                                          ;=czas Ciemny/Swieci
                        inc A                   ;!255+1=0! byte !
                        mov Disp_D_L_Time,A

                        cjne A,#0,Wys_i_Odczyt_Klaw_00
                        ;wg. LOW < 255 nastepny = 00 !
                        ;A=0 t.z.n. Disp_D_L_Time=0
                        ;czas uplynal

                        ;Wg. OFF/Tryb_Wpr
                        mov A,Tryb_Wpr
Czy_Tryb_Wpr:           cjne A,#01,Tryb_Wpr_NIE
                        ;A=1 Jest Tryb wprowadzania

Tryb_Wpr_TAK:           ;"szybkie miganie"
                        ; Czas Swieci/NIE Swieci "Short"
                        mov Disp_D_L_Time,#D_L_Time_Short
                        ;jest tryb wprowadzania
                        jmp Zmiana_Migac_TAK_NIE

Tryb_Wpr_NIE:           ;"wolne miganie"
                        ; Czas Swieci/NIE Swieci "Long"
                        mov Disp_D_L_Time,#D_L_Time_Long
                        ;NIE tryb wprowadzania
                        jmp Zmiana_Migac_TAK_NIE


Zmiana_Migac_TAK_NIE:   ;Czas swiecenia/Nie swiecenia uplynal
                        ; - zmienic na przeciwny
                        mov A,Disp_DL
                        cjne A,#1,Wys_i_Odczyt_Klaw_ON
Wys_i_Odczyt_Klaw_OFF:  ;A=1=Jest zapalony to zgas
                        ;NIE swiec
                        mov Disp_DL,#0
                        mov Maska_pip,#00000000b        ;"pipanie" w takt
                                                        ;migania ,"SWIECI=pipaj"
                        jmp Wys_i_Odczyt_Klaw_00

Wys_i_Odczyt_Klaw_ON:   ;A=0=Jest wygaszony to zapal
                        ;SWIEC
                        mov Disp_DL,#1
                        ;czy tryb wprowadzania
                        mov A,Tryb_Wpr
Wys_i_Odczyt_Klaw_TW:   cjne A,#01,Wys_i_Odczyt_Klaw_NTW
                        ;A=1 Jest Tryb wprowadzania
                        mov Maska_pip,#01000000b
Wys_i_Odczyt_Klaw_NTW:  jmp Wys_i_Odczyt_Klaw_00

Wys_i_Odczyt_Klaw_00:   ;wyswietlanie segmentow wg. Nr-u aktualnie wyswietl.
                        mov A,Disp_Nr         ;Ktory segment jest swiecacy ?
;Segment_0_Poczatek
Wys_i_Odcz_Klaw_Segm_0: ;Czy wyswietlany jest segment 0-wy
                        cjne A,#00,Wys_i_Odcz_Klaw_Segm_1
                        ;tak A=0,wyswietlany jest 0-seg.,wpisz do 1-go i zapal go
                        ;wpisac Dane dla 1-go
                        ;zgasic  0-wy
                        ;zapalic 1-szy
                        ;Przygotowac dla seg. 1-go
                        mov A,Disp_Data_010  ;"Dziesiatki"
                        anl A,#00001111b ;Tylko dane - bity 3..0 !
                        push Acc    ;Przechowanie

                        mov A,Disp_DL    ;jest Miganie czy Nie
                        ;Jezeli jest MIGANIE i Faza - SWIEC to dane normalne
Wys_i_Odcz_Klaw_Segm_0_00:
                        cjne A,#1,Wys_i_Odcz_Klaw_Segm_0_OFF
Wys_i_Odcz_Klaw_Segm_0_ON:  ;1=Swieci - Dla migaj - faza Swiec i "pip"
                        pop Acc          ;Dane do wyswietlenia
                        anl A,#00001111b ;Tylko dane - bity 3..0 !
                                         ;bity 7..4 stroby !
                        jmp Wys_i_Odcz_Klaw_Segm_0_end

Wys_i_Odcz_Klaw_Segm_0_OFF: ;0=Zgaszone - Dla migaj - faza Zgaszony
                        pop Acc          ;Dane do wyswietlenia
                        orl A,#00001111b ;faza NIE Swiec bity 3..0=F
                                         ;zaden segmeny NIE SWIECI
                                         ;bity 7..4 stroby !
                        jmp Wys_i_Odcz_Klaw_Segm_0_end

Wys_i_Odcz_Klaw_Segm_0_end: ;Dane do wyswietlenia A=0000xxxx ustalone
                        orl A,Maska_pip  ;ustawic bit P1.6=1="pipaj"/0=NIE"pipaj"
                        mov  P1,A        ;Dane do wyswietlenia - bez strobow !

                        setb P3.0        ;WYGAS STROB dla seg.0
                        ;Zapisz Dane dla segm. 1-szy
                        setb P1.7        ;STROB Zapisz Dane do LCD1
                        mov A,#1
                        call Delta_Time_Ms
                        clr  P1.7       ;STROB Zapisz Dane do LCD1
                        mov A,#1        ;szerokosc strobu=1 ms
                        call Delta_Time_Ms
                        clr  P3.1       ;zapal segment 1-szy
                        mov  Disp_Nr,#01
                        jmp Wys_i_Odczyt_Klaw_PrawieKoniec
;Segment_0_Koniec

;Segment_1_Poczatek
Wys_i_Odcz_Klaw_Segm_1: ;Czy wyswietlany jest segment 1-szy
                        cjne A,#01,Wys_i_Odcz_Klaw_Segm_2
                        ;tak A=1 , wyswietlany jest 1-seg.
                        ;wpisac Dane dla 2-go
                        ;zgasic  1-szy
                        ;zapalic 2-gi
                        ;Przygotowac dla seg. 2-go
                        mov A,Disp_Data_100  ;"Setki"
                        anl A,#00001111b ;Tylko dane - bity 3..0 !
                        push Acc    ;Przechowanie

                        mov A,Disp_DL    ;jest Miganie czy Nie
Wys_i_Odcz_Klaw_Segm_1_00:
                        cjne A,#1,Wys_i_Odcz_Klaw_Segm_1_OFF
Wys_i_Odcz_Klaw_Segm_1_ON:  ;1=Swieci - Dla migaj - faza Swiec
                        pop Acc          ;Adres danych do wyswietlenia
                        anl A,#00001111b ;Tylko dane - bity 3..0 !
                                         ;bity 7..4 stroby !
                        cjne A,#00,Wys_i_Odcz_Klaw_Segm_1_OF
                        ;Wygasic ten segment
                        orl A,#00001111b
Wys_i_Odcz_Klaw_Segm_1_OF:  jmp Wys_i_Odcz_Klaw_Segm_1_end

Wys_i_Odcz_Klaw_Segm_1_OFF: ;0=Zgaszone - Dla migaj - faza Zgaszony
                        pop Acc          ;Adres danych do wyswietlenia
                        orl A,#00001111b ;faza NIE Swiec bity 3..0=F
                                         ;zaden segmeny NIE SWIECI
                                         ;bity 7..4 stroby !
                        jmp Wys_i_Odcz_Klaw_Segm_1_end

Wys_i_Odcz_Klaw_Segm_1_end: ;Dane do wyswietlenia A=0000xxxx ustalone
                        orl A,Maska_pip ;ustawic bit P1.6=1="pipaj"/0=NIE"pipaj"
                        mov  P1,A       ;Dane do wyswietlenia - bez strobow !

                        setb P3.1       ;WYGAS STROB dla seg.1

                        ;Zapisz Dane dla Seg. 2-go
                        setb P1.7       ;STROB Zapisz Dane do Seg. 2-go
                        mov A,#1
                        call Delta_Time_Ms
                        clr  P1.7       ;STROB Zapisz Dane do LCD2
                        mov A,#1
                        call Delta_Time_Ms
                        clr  P3.2       ;zapal segment 2-gi

                        mov  Disp_Nr,#02
                        jmp Wys_i_Odczyt_Klaw_PrawieKoniec
;Segment_1_Koniec

;Segment_2_Poczatek
Wys_i_Odcz_Klaw_Segm_2: ;Czy wyswietlany jest segment 2-gi
                        cjne A,#02,Wys_i_Odcz_Klaw_Segm_x
                        ;tak A=2 , wyswietlany jest 2-seg.
                        ;wpisac Dane dla 0-go ! nastepny po seg. 2 !
                        ;zgasic  2-gi
                        ;zapalic 0-wy
                        ;Przygotowac dla seg. 0-go
                        mov A,Disp_Data_001  ;"Jednosci"
                        anl A,#00001111b ;Tylko dane - bity 3..0 !
                        push Acc    ;Przechowanie

                        mov A,Disp_DL       ;jest Miganie czy Nie
Wys_i_Odcz_Klaw_Segm_2_00:
                        cjne A,#1,Wys_i_Odcz_Klaw_Segm_2_OFF
Wys_i_Odcz_Klaw_Segm_2_ON:  ;1=Swieci - Dla migaj - faza Swiec
                        pop Acc             ;Adres danych do wyswietlenia
                        anl A,#00001111b    ;Tylko dane - bity 3..0 !
                                            ;bity 7..4 stroby !
                        jmp Wys_i_Odcz_Klaw_Segm_2_end
Wys_i_Odcz_Klaw_Segm_2_OFF: ;0=Zgaszone - Dla migaj - faza Zgaszony
                        pop Acc             ;Adres danych do wyswietlenia
                        orl A,#00001111b    ;faza NIE Swiec bity 3..0=F
                                            ;zaden segmeny NIE SWIECI
                                            ;bity 7..4 stroby !
                        jmp Wys_i_Odcz_Klaw_Segm_2_end

Wys_i_Odcz_Klaw_Segm_2_end: ;Dane do wyswietlenia A=0000xxxx ustalone
                        orl A,Maska_pip     ;ustawic bit P1.6=1="pipaj"/0=NIE"pipaj"
                        mov  P1,A       ;Dane do wyswietlenia - bez strobow !

                        setb P3.2       ; WYGAS STROB dla seg.2

                        ;Zapisz Dane dla Seg. 0-go
                        setb P1.7       ;STROB Zapisz Dane do Seg.0-go
                        mov A,#1
                        call Delta_Time_Ms
                        clr  P1.7       ;STROB Zapisz Dane do LCD0
                        mov A,#1
                        call Delta_Time_Ms

                        clr  P3.0       ;zapal segment 0-wy
                        mov  Disp_Nr,#00h
                        jmp Wys_i_Odczyt_Klaw_PrawieKoniec

Wys_i_Odcz_Klaw_Segm_x: ;Nieokreslono segmentu do wyswietlenia
                        ; A ani 0,1,2 - bledne dane -
                        ;wpisz dane Wejsciowe czyli 00
                        mov  Disp_Nr,#00h
                        jmp Wys_i_Odczyt_Klaw_PrawieKoniec
;Segment_2-Koniec

Wys_i_Odczyt_Klaw_PrawieKoniec:
                        ;We: Swieci seg. 0,1 lub 2- ,
                        ;odczyt klawiszy : wg strobu
                        call Odczyt_Klawiszy_Kolumny_012
                        ;Wy:Klaw_Kod_ASCII_0,1,2
                        ;    "0".."9" ,"+" ,"-" - w ASCII
                        ;255=FFh gdy nie nacisnieto klawisza

                        pop aR1
                        pop aR0
                        pop Acc

Wys_i_Odczyt_Klaw_End:  ret
;############################
Odczyt_Klawiszy_Kolumny_012:
;WE:    1-den ze strobow P3.2..P3.0 - jest aktywny = "0"
;       na P3.7..P3.3 (P3.6-niedostepne !) jest "0" gdy klwisz nacisniety
;WY:    Klaw_ASCII_x= Odczytany kod ASCII
;       po przetworzeniu :  --> T_K_O --> T_K_Rz
;       Klaw_Kod_ASCII : "0".."9" (30h..38h)
;                         "+"=43dec=2Bh
;                         "-"=45dec=2Dh
;                                   FFh gdy nie nacisnieto

                        push Acc
                        push aR0
                        push aR7

                        mov A,Disp_Nr           ;nr.segmentu swiecacego
                                                ;z tej kolumny bedzie czytany
                                                ;klawisz
                        add A,#Klaw_ASCII_0     ;adres bazowy
                        mov R0,A                ;do R0

                        mov A,P3                ;Kod Odczytany z P3
                        ;ustaw bit P3.6 !!! MC = AT89x051 niedostepny !!!
                        orl A,#01000000b
                        ;( tablica : T_K_0 )
                        mov Klaw_Kod_Odcz,A     ;Zapamietanie
                                                ;Kod Odczytany
                                                ;( tablica : T_K_0 )

                        mov R7,#IlElTab  ;Licznik=ilosc elem. tablicy
                        mov DPTR,#T_K_O  ;Adres Tabeli Kodow Odczytanych

Odczyt_Klawiszy_Kol_Petla_00:   ;Petla przeszukiwania i porownania tablic
                        mov A,#00h
                        movc A,@A+DPTR          ;Kod z tabeli T_K_O
                        ;Porownanie : Kod z tabeli T_K_O=Kod odczytany
                        cjne A,Klaw_Kod_Odcz,Odczyt_Klawiszy_Kol_Petla_N
                        ;TAK , Kod odczytany jest w tabeli !
                        mov A,#(T_K_Rz-T_K_O)   ;Roznica adresow tabel
                        movc A,@A+DPTR          ;pobranie z tabeli T_K_Rz w ASCII
                        mov @R0,A               ;Kod rzeczywisty ASCII !
                        jmp Odczyt_Klawiszy_Kolumny_012_End

Odczyt_Klawiszy_Kol_Petla_N:    ;Sprawdz nastepny element
                        inc DPTR
                        djnz R7,Odczyt_Klawiszy_Kol_Petla_00

                        ;Kod Nieznany
                        ;Brak kodu w tabeli czyli NIE nacisnieto kl.
                        ;lub np. 2-klawisze razem
                        mov @R0,#0FFh
                        jmp Odczyt_Klawiszy_Kolumny_012_End

Odczyt_Klawiszy_Kolumny_012_End:

                        pop aR7
                        pop aR0
                        pop Acc

                        ret
;==========================================================
Anal_Klaw_i_Wyk_Zad_Funk: ;ANALiza KLAWiszy I WYKonanie ZADanej FUNKcji
;WE:Klaw_do_Analizy
;WY: Wykonane funkcje

                        ;Stan ON(ZALaczony) czy OFF(WYLaczony)
                        mov A,Power_ON_OFF
                        cjne A,#1,AnKl_Power_OFF_jmp
                        jmp AnKl_Power_ON

AnKl_Power_OFF_jmp:     ;Zbyt daleki skok dla "cjne"
                        ;dlatego trzeba posredniego skoku !!
                        jmp AnKl_Power_OFF

AnKl_Power_ON:          ;Stan ON=ZALaczony
                        ;Pobranie Kodu klawisza
                        mov A,Klaw_do_Analizy
;*****
;<PLUS-_ON=Increment>
ON_PLUS_Klawisz:        ;Czy "+" ?
                        cjne A,#'+',ON_MINUS_Klawisz ;Byc moze "-" ?
                        ;Tak - "+" : INC bo Power-ON

                        ;Tryb INCrementacji
                        ;Czy Wart. Nastaw. <255 ?
                        mov A,Relay_Data_BIN
                        cjne A,#255,ON_PLUS_INC_OK
                        ;Relay_Data_BIN=225 nie wolno dalej zwiekszac
                        jmp ON_PLUS_Koniec

ON_PLUS_INC_OK:         ;mozna dodac 1-den
                        inc Relay_Data_BIN
                        mov A,Relay_Data_BIN

                        ;WE:A=Relay_Data_BIN
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!

                        ;WE:A
                        call Nowa_War_do_Przek ;NOWA WARtosc DO PRZEKaznikow

                        jmp ON_PLUS_Koniec

ON_PLUS_Koniec:         jmp Anal_Klaw_i_Wyk_Zad_Funk_End

;*****
;<MINUS-ON=Decrement>
ON_MINUS_Klawisz:       ;Czy "-" ?
                        cjne A,#'-',ON_ZERO_Klawisz ;Byc moze "1".."9" ?
                        ;Tak - "-" :  DEC bojest ZALaczony

                        ;Tryb DECrementacji
                        ;Czy Wart. Nastaw. >0 ?
                        mov A,Relay_Data_BIN
                        cjne A,#0,ON_MINUS_DEC_OK
                        ;A=0 czyli Relay_Data_BIN=0 nie wolno dalej zmniejszac
                        jmp ON_MINUS_Koniec

ON_MINUS_DEC_OK:        ;mozna odjac 1-den
                        dec Relay_Data_BIN
                        mov A,Relay_Data_BIN

                        ;WE:A=Relay_Data_BIN
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!

                        call Nowa_War_do_Przek
                        jmp ON_MINUS_Koniec

ON_MINUS_Koniec:        jmp Anal_Klaw_i_Wyk_Zad_Funk_End
;*****

;<ZERO>
ON_ZERO_Klawisz:        ;Cz to "0"
                        cjne A,#'0',ON_1_9_Klawisze
                        ;Tak - klawisz "0"
ON_ZERO_Power_OFF:      ;jest ZALaczony to WYLacz

                        ;WYL przekazniki
                        setb P1.6       ;Strob RESET ON
                        mov A,#10       ;Czas RESET
                        call Delta_Time_Ms
                        clr  P1.6       ;Strob RESET OFF
                        mov A,Relay_Data_BIN

                        ;WE:A=j.w
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!

                        mov Power_ON_OFF,#0     ;WYLacz
                        mov Disp_Flash_ON,#1    ;MIGAJ
                        mov Tryb_Wpr,#0         ;Tryb Wprowadzania

                        jmp  ON_ZERO_Koniec

ON_ZERO_Koniec:         jmp Anal_Klaw_i_Wyk_Zad_Funk_End
;*****

;<1>..<9>
ON_1_9_Klawisze:        ;Czy klawisz z zakresu "1"..."9"
                        ;kody ASCII !!
                        ;!!! klawisz "0" - inaczej ! patrz "OFF_czy_cyfra_0:" !!

ON_1_9_Czy_1:           mov A,Klaw_do_Analizy
                        clr C           ;bedzie odejmowanie !
                        subb A,#'1'
                        ;gdy A<"1"(ASCII)!  to CY=1
                        ;gdy A=>"1"         to CY=0
                        jnc ON_1_9_Czy_9
                        ;CY=1 czyli A<"1"
                        ;nie moze to byc klawisz
                        ;z zakresu 1..9
                        jmp ON_1_9_Klawisze_Koniec

ON_1_9_Czy_9:           mov A,Klaw_do_Analizy
                        clr C           ;bedzie odejmowanie !
                        subb A,#3Ah     ;3Ah nastepny znak po "9"
                        ;gdy A<3Ah  to CY=1  OK ! Mniejsze od 0Ah=10dec ,
                        ;czyli ....5,6,7,8,9 !
                        ;gdy A>=3Ah to CY=0  nie jest w sakresie 0..9 !
                        jc ON_OK_0_1_9
                        ;CY=0 - poza zakresem
                        jmp ON_1_9_Klawisze_Koniec

ON_OK_0_1_9:            ;Cyfra z zakresu : "1".."9"
                        ;Wszystkie w ASCII !
                        ;Stan : ZAL , nacisnieto : "1".."9"
                        setb P1.6       ;Strob RESET ON
                        mov A,#10       ;Czas impulsu RESET
                        call Delta_Time_Ms
                        clr  P1.6       ;Strob RESET bOFF
                        ;zmiana stanu : ON(ZALaczony) -> OFF(WYLaczony)
                        mov Power_ON_OFF,#0     ;WYL
                        mov Disp_Flash_ON,#1    ;MIGAJ
                        mov Il_Wprow_Cyfr,#0
                        jmp OFF_1_9_z_ON

ON_1_9_Klawisze_Koniec: jmp Anal_Klaw_i_Wyk_Zad_Funk_End

;============================
;Power_ON_OF=0 - Stan OFF(WYLaczony)
AnKl_Power_OFF:         ;Stan OFF
;*****
                        ;Pobranie Kodu klawisza
                        mov A,Klaw_do_Analizy
;<ZERO>
OFF_ZERO_Klawisz:       ;Czy to "0"
                        cjne A,#'0',OFF_1_9_Klawisze
                        ;Tak - "0"

OFF_ZERO_Czy_Normalny:  ;Czy "0" jest jako normalny klawisz "0" czy jako ZALacz?
                        mov A,Tryb_Wpr
                        cjne A,#0,OFF_1_9_0_jako_Norm ;"0" Jako normalny klawisz
OFF_ZERO_Power_ON:      ;"0" jako ZALacz bo jest WYLaczony

                        ;Odtworzenie
                        mov Disp_Flash_ON,#0    ;NIE MIGAJ
                        mov Disp_DL,#1          ;Swiec
                        mov Power_ON_OFF,#1     ;ZALacz
                        mov Tryb_Wpr,#0

                        mov A,Relay_Data_BIN

                        ;WE:A=Relay_Data_BIN
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!

                        ;WE:A
                        call Nowa_War_do_Przek

                        jmp  OFF_ZERO_Koniec

OFF_ZERO_Koniec:        jmp Anal_Klaw_i_Wyk_Zad_Funk_End

;*****

;<1>..<9>
OFF_1_9_Klawisze:       ;Czy klawisz z zakresu "1"..."9"
                        ;kody ASCII !!
                        ;!!! klawisz "0" - inaczej !!!

OFF_1_9_Czy_1:          mov A,Klaw_do_Analizy
                        clr C           ;bedzie odejmowanie !
                        subb A,#'1'
                        ;gdy A<"1"(ASCII)!  to CY=1
                        ;gdy A=>"1"         to CY=0
                        jnc OFF_1_9_Czy_9
                        ;CY=1 czyli A<"1"
                        ;nie moze to byc klawisz
                        ;z zakresu 1..9
                        jmp OFF_Czy_PLUS

OFF_1_9_Czy_9:          mov A,Klaw_do_Analizy
                        clr C           ;bedzie odejmowanie !
                        subb A,#3Ah     ;3Ah nastepny znak po "9"
                        ;gdy A<3Ah  to CY=1  OK ! Mniejsze od 0Ah=10dec !
                        ;gdy A>=3Ah to CY=0  nie jest w sakresie 0..9 !
                        ;mov Tryb_Wpr,#1 !!! dopiero po wprowadzeniu
                        ;                    1-szej cyfry !!!
                        jc OFF_OK_1_9
                        ;CY=0 - poza zakresem
                        jmp OFF_Czy_PLUS

OFF_OK_1_9:             ;Cyfra z zakresu "0" , "1".."9"
                        ;Wszystkie w ASCII !

OFF_1_9_0_jako_Norm:    ;WE dla "0" w trybie wprowadzania
                        ;dla OFF
OFF_1_9_z_ON:           ;WE po nacisnieciu "1".."9"
                        ;w stanie ON !

                        mov A,Il_Wprow_Cyfr

OFF_Czy_Cyfra_0:        ;czy cyfra 0-wa ?
                        cjne A,#0,OFF_Czy_Cyfra_1
                        ;Wprowadzamy 0-wa cyfre
                        ;1-ki
                        ;Nie swieca : 100-ki i 10-ki

                        mov A,Klaw_do_Analizy
                        ;z ASCII na BIN
                        clr C           ;bedzie odejmowanie !
                        subb A,#30h
                        ;A="czyste" np. "1"=31h-30h=1 !
                        ;mov B,#1  !!! NIE TRZEBA MNOzyc 1*1=1
                        ;mul AB

                        mov Relay_Data_BIN,A
                        ;WE:A=j.w.
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!

                        mov Disp_Data_100,#0Fh  ;NIE Swieci
                        mov Disp_Data_010,#0Fh  ;NIE Swieci
                        inc Il_Wprow_Cyfr       ;wprowadzono 1-cyfr

                        mov Tryb_Wpr,#1         ;Wprowadzono 1-sza cyfre !!!
                        jmp Anal_Klaw_i_Wyk_Zad_Funk_End

OFF_Czy_Cyfra_1:        ;czy cyfra 1-sza ?
                        cjne A,#1,OFF_Czy_Cyfra_2
                        ;Wprowadzamy 1-sza cyfre
                        ;10-ki
                        ;Nie swieca : 100-ki

                        mov A,Klaw_do_Analizy
                        ;Z ASCII na BIN
                        clr C           ;bedzie odejmowanie !
                        subb A,#30h
                        ;A="czyste" np. "1"=31h-30h=1 !

                        mov R0,A        ;A="jednosci"
                        mov A,Relay_Data_BIN
                        mov B,#10       ;przenies "byle"1-ki na "10-KI"
                        mul AB
                        add A,R0        ;dodaj "1-ci"

                        mov Relay_Data_BIN,A
                        ;WE:A=j.w.
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!

                        mov Disp_Data_100,#0Fh  ;NIE Swieca tylko "100-ki"
                        inc Il_Wprow_Cyfr       ;wprowadzono 2-ga
                        jmp Anal_Klaw_i_Wyk_Zad_Funk_End

OFF_Czy_Cyfra_2:        ;czy cyfra 2-ga ?
                        cjne A,#2,OFF_Za_Duzo_Cyfr
                        ;Wproweadzamy 2-ga cyfre
                        ;100-ki
                        ;Wszystkie swieca

                        mov A,Klaw_do_Analizy
                        ;Z ASCII na BIN
                        clr C           ;bedzie odejmowanie
                        subb A,#30h
                        ;A="czyste" np. "1"=31h-30h=1 !
                        mov R0,A        ;"1-ki"
                        mov A,Relay_Data_BIN
                        mov B,#10       ;10x10 setki , 1-ki na 10-ki
                        mul AB    ;Wynik w A=Low , B=High , ustawia OVerflow
                        ;Kontrola czy liczba w Relay_Data_BIN
                        ;nie przekroczy 255 !
                        ;jezeli juz po mnozeniu jest OV=1 to przepelnienie 255 !
OFF_Czy_w_Zakr_255:     jnb OV,OFF_gdy_po_Mnozeniu_OK   ;OK nie przkracza 255
                        ;OV=1 czyli A*B>255
                        ;Liczba zbyt duza - NIE ZEZWOLIC na zapis !
                        jmp Anal_Klaw_i_Wyk_Zad_Funk_End

OFF_gdy_po_Mnozeniu_OK: ;Czy po dodaniu takze OK
                        clr C
                        add A,R0        ;dodaj 1-ki
                        jnc OFF_do_Przekaznikow ;OK-miesci sie w zakresi <=255
                        ;Liczba zbyt duza - NIE ZEZWOLIC na zapis !
                        jmp Anal_Klaw_i_Wyk_Zad_Funk_End

OFF_do_Przekaznikow:    ;wartosc w granicach : 0-255 mozna zapisac
                        mov Relay_Data_BIN,A
                        ;WE:A=j.w.
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!
                        ;tylko wyswietla ! do przekaznikow dopiero po ON !
                        inc Il_Wprow_Cyfr       ;wprowadzono 3-cyfre
                        jmp Anal_Klaw_i_Wyk_Zad_Funk_End

OFF_Za_Duzo_Cyfr:       ;np. wprowadzono juz 3 cyfry i nadal chce sie wpisywac !
                        jmp Anal_Klaw_i_Wyk_Zad_Funk_End


;*****

OFF_Czy_PLUS:           ;Czy "+" ?
                        mov A,Klaw_do_Analizy
                        cjne A,#'+',OFF_Czy_MINUS ;Byc moze "-" ?
                        ;Tak - "+" jako <ENTER> bo tryb wprowadzania
;*****
;
;<PLUS_OFF>=<ENTER>     ;Uwagi :
                        ;1. nie wychodzi z trybu "migania"- WYLacz
                        ;2. czeka na "0"-jako ZALacz !
OFF_PLUS:               mov Disp_Flash_ON,#1    ; MIGAJ

                        mov Tryb_Wpr,#0         ;wyjscie z trybu Wprowadzania
                        mov Il_Wprow_Cyfr,#0    ;przygotowny do nastep. Wprowadz

                        mov A,Relay_Data_BIN    ;OK do wyswietlenia
                                                ;ale NIE DO PRZEKAZNIKOW !!!
                        ;WE:A=Relay_Data_BIN
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!

                        jmp Anal_Klaw_i_Wyk_Zad_Funk_End

OFF_Czy_MINUS:          ;Czy "-" ?
                        mov A,Klaw_do_Analizy
                        cjne A,#'-',Anal_Klaw_i_Wyk_Zad_Funk_End
                        ;Tak - "-" jako <CANCEL> bo tryb wprowadzania
;*****
;
;<MINUS_OFF>=<CANCEL>
OFF_MINUS:              mov A,Tryb_Wpr
                        cjne A,#1,Anal_Klaw_i_Wyk_Zad_Funk_End
                        ;jest tryb wprowadz wiec ZERUJ
                        mov Il_Wprow_Cyfr,#0
                        mov Relay_Data_BIN,#00
                        mov A,Relay_Data_BIN
                        ;WE:A=Relay_Data_BIN
                        call Byte_na_liczbe_100_10_1
                        ; A jest zachowane !!!

                        jmp Anal_Klaw_i_Wyk_Zad_Funk_End

Anal_Klaw_i_Wyk_Zad_Funk_End:
                        ret
;==========================================================
Byte_na_liczbe_100_10_1:
;WE:A=wartosc do przetworzenia
; A jest zachowane !!!
;A=Relay_Data_BIN=Binarna wartosc nastawy (i do zapisu do przekaznikow)
;WY:
;Disp_Data_100   Wartosc nastawiona - 100-ki BCD bity 3..0
;Disp_Data_010   Wartosc nastawiona -  10-ki BCD bity 3..0
;Disp_Data_001   Wartosc nastawiona -   1-ki BCD bity 3..0
                                push Acc  ;A na stos zeby zachowac wartosc

Byte_na_liczbe_100_10_1_100:    ;Obliczenie "setek" wartosci WEjsciowej
                                mov B,#100          ;dzielnik "setek" wyniku
                                div AB              ;A/100
                                                    ;A=ilosc "setek"
                                                    ;B=reszta="10-ki i "1-ki"
                                anl A,#00001111b    ;aby na bitach 7-4 byly "0"
                                mov Disp_Data_100,A ;Disp_Data_100=ilosc "setek"

                                cjne A,#0,Byte_na_liczbe_100_10_1_10
                                ;100-ki = 0 wiec NIE Swiec
                                mov Disp_Data_100,#00001111b

Byte_na_liczbe_100_10_1_10:     ;Obliczenie "dziesiatek" wartosci WEjsciowej
                                mov A,B             ;B=reszta z dzielenia
                                                    ;przez 100="10-ki" i :1-ki"
                                mov B,#10           ;dzielnik "dzisiatek" wyniku
                                div AB              ;A/10
                                                    ;A=ilosc "dziesiatek"
                                                    ;B=reszta="1-ki"
                                anl A,#00001111b    ;aby na bitach 7-4 byly "0"
                                mov Disp_Data_010,A ;Disp_Data_010=ilosc "dzisiatek"

                                cjne A,#0,Byte_na_liczbe_100_10_1_1
                                ;10-ki = 0 wiec moga NIE Swiecic
                                ;jezeli 100-ki sa takze 0 !
                                mov A,Disp_Data_100
                                cjne A,#0Fh,Byte_na_liczbe_100_10_1_1
                                ;100-ki juz wygaszone
                                ;wiec mozna 10-ki takze wygasic
                                mov Disp_Data_010,#00001111b

Byte_na_liczbe_100_10_1_1:      ;Obliczenie "jednostek" wartosci WEjsciowej
                                mov A,B             ;B=reszta z dzielenia
                                                    ;przez 10="1-ki"
                                                    ;B="jednostki"
                                                    ;wiec nie trzeba przetwarzac !
                                anl A,#00001111b    ;aby na bitach 7-4 byly "0"
                                mov Disp_Data_001,A ;Disp_Data_001=ilosc
                                                    ;"jednostek" w kodzie BCD
                                ;"1-ki" swieca ZAWSZE nawet gdy sa "0" !
Byte_na_liczbe_100_10_1_End:    pop  Acc            ;stos do A-odtworzenie wartosci
                                ret
;WY:
;Disp_Data_100   Wartosc nastawiona - 100-ki BCD bity 3..0 - gdy="0" to nie SWIECA
;Disp_Data_010   Wartosc nastawiona -  10-ki BCD bity 3..0 - gdy="0" i "100"-ki="0"
;                                                            nie SWIECA
;Disp_Data_001   Wartosc nastawiona -   1-ki BCD bity 3..0 - SWIECA ZAWSZE !
;==========================================================
Nowa_War_do_Przek:              ;Zapis do przekaznikow
;WE:A=Relay_Data_BIN
;WY:Przekazniki ustawione
;Zapis do przekaznikow

Relay_LOW:                      ;Pobierz dane LOW
                                mov A,Relay_Data_BIN
                                ;Zamien 1/2 bytes
                                swap A
                                ;Wyodrebnij bity
                                anl A,#00001111b
                                ;zapisz 7654
                                orl A,Maska_pip ;"pipanie" w Trybie Wprowadz. ?
                                mov P1,A

                                setb P1.5       ;Strob-ON
                                push Acc
                                mov A,#1        ;Szerokosc STROBU=1ms
                                call Delta_Time_Ms
                                pop Acc
                                clr  P1.5       ;Strob-OFF

Relay_HIGH:                     ;Pobierz dane High
                                mov A,Relay_Data_BIN
                                ;Wyodrebnij bity
                                anl A,#00001111b
                                ;Zapisz 3210
                                orl A,Maska_pip ;"pipanie" w Trybie Wprowadz. ?
                                mov P1,A
                                setb P1.4       ;Strob-ON
                                push Acc
                                mov A,#1        ;Szerokosc STROBU=1ms
                                call Delta_Time_Ms
                                pop Acc
                                clr  P1.4       ;Strob-OFF

Nowa_War_do_Przek_End:
                                ret
;==========================================================
Delta_Time_Ms:               ;czas zwloki w Milisekundach

;WE:A=czas w Ms
                             push Acc
                             push aR0
                             push aR1
                             push aR2

                             cjne A,#0,Delta_Time_Ms_Start
                             jmp Delta_Time_Ms_End

Delta_Time_Ms_Start:

                             mov R0,A

Delta_Time_R1_Load:          mov R1,#2

Delta_Time_R2_Load:          mov R2,#255
Delta_Time_R2_Dec:           djnz R2,Delta_Time_R2_Dec

Delta_Time_R1_Dec:           djnz R1,Delta_Time_R2_Load

Delta_Time_R0_Dec:           djnz R0,Delta_Time_R1_Load
Delta_Time_Ms_End:
                             pop  aR2
                             pop  aR1
                             pop  aR0
                             pop Acc
                             ret
;==========================================================
Pipaj_A_razy_100_ms:
;WE: A= ilosc 100-tek ms
                            push Acc
                            push aR0
                            push aR1

                            mov R0,A
                            mov R1,#100     ;A*100=1000 ms

Dec_100:                    mov A,#1
                            call Delta_Time_Ms
                            djnz R1,Dec_100
                            ;100 ms uplynelo
                            ;zaladuj ponownie
                            mov R1,#100
                            ;sprawdz czy 10-ki uplynely
                            djnz R0,Dec_100
                            ;Minela czas

Pipaj_A_razy_100_ms_End:    pop aR1
                            pop aR0
                            pop Acc
                            ret
;==========================================================
;SEGMENT stalych DANYCH : nie musi byc na koncu , ale dobrze gdy jest !
;Talice dla przetworzenia Kod_Odcz -> Kod_ASCII
T_K_O:
;Tablice Kodow Odczytanych :
;Kol=0          P3.0
;Wiersz=0..3    P3.3..P3.7
;               P3.6 - niedostepny !
DB  0F6h ;"-"
DB  0EEh ;"9"
DB  0DEh ;"6"
DB  07Eh ;"3"
;Kol=1          P3.1
;Wiersz=0..3    P3.3..P3.7
;               P3.6 - niedostepny !
DB  0F5h ;"0"
DB  0EDh ;"8"
DB  0DDh ;"5"
DB  07Dh ;"2"
;Kol=2          P3.2
;Wiersz=0..3    P3.3..P3.7
;               P3.6 - niedostepny !
DB  0F3h ;"+"
DB  0EBh ;"7"
DB  0DBh ;"4"
DB  07Bh ;"1"

T_K_Rz:
;Tablice Kodow Rzeczywistych_ASCII:
;Kol=0          P3.0
;Wiersz=0..3    P3.3..P3.7
;               P3.6 - niedostepny !
DB  2Bh ;"+"
DB  31h ;"1"
DB  34h ;"4"
DB  37h ;"7"
;Kol=1          P3.1
;Wiersz=0..3    P3.3..P3.7
;               P3.6 - niedostepny !
DB  30h ;"0"
DB  32h ;"2"
DB  35h ;"5"
DB  38h ;"8"
;Kol=2          P3.2
;Wiersz=0..3    P3.3..P3.7
;               P3.6 - niedostepny !
DB  2Dh ;"-"
DB  33h ;"3"
DB  36h ;"6"
DB  39h ;"9"
;############################
Sygnatura_Programu:
DB 'Program : ZAS_WAR.A51 w Asembler dla AT89C2051 .'
DB 'Autor : MIM .'
DB 'VER: P3 dla ukladu .'
DB 'Ostatnia edycja : 23.08.2003 .'
;############################
;{Koniec programu - "End"}
end

